import {VSBuffer}from'@vscode-alt/monaco-editor/esm/vs/base/common/buffer.js';import {FileOperationError}from'./files.js';import {isUndefinedOrNull}from'@vscode-alt/monaco-editor/esm/vs/base/common/types.js';/* tslint:disable */
class TextFileOperationError extends FileOperationError {
  textFileOperationResult;
  options;
  constructor(message, textFileOperationResult, options) {
    super(message, "FILE_OTHER_ERROR" /* FileOperationResult.FILE_OTHER_ERROR */);
    this.textFileOperationResult = textFileOperationResult;
    this.options = options;
  }
  static isTextFileOperationError(obj) {
    return obj instanceof Error && !isUndefinedOrNull(obj.textFileOperationResult);
  }
}
/**
 * Helper method to convert a snapshot into its full string form.
 */
function snapshotToString(snapshot) {
  const chunks = [];
  let chunk;
  while (typeof (chunk = snapshot.read()) === 'string') {
    chunks.push(chunk);
  }
  return chunks.join('');
}
function stringToSnapshot(value) {
  let done = false;
  return {
    read() {
      if (!done) {
        done = true;
        return value;
      }
      return null;
    }
  };
}
class TextSnapshotReadable {
  snapshot;
  preamble;
  preambleHandled;
  constructor(snapshot, preamble) {
    this.snapshot = snapshot;
    this.preamble = preamble;
  }
  read() {
    let value = this.snapshot.read();
    // Handle preamble if provided
    if (!this.preambleHandled) {
      this.preambleHandled = true;
      // Handle preamble if provided
      if (typeof this.preamble === 'string') {
        if (typeof value === 'string') {
          value = this.preamble + value;
        } else {
          value = this.preamble;
        }
      }
    }
    if (typeof value === 'string') {
      return VSBuffer.fromString(value);
    }
    return null;
  }
}
function toBufferOrReadable(value) {
  if (typeof value === 'undefined') {
    return undefined;
  }
  if (typeof value === 'string') {
    return VSBuffer.fromString(value);
  }
  return new TextSnapshotReadable(value);
}export{TextFileOperationError,TextSnapshotReadable,snapshotToString,stringToSnapshot,toBufferOrReadable};//# sourceMappingURL=textfiles.js.map
